from sys import stderr

from sqlalchemy.exc import SQLAlchemyError

from diner import DinerDatabase, Menu, Item, Order, OrderItem


def add_starter_data(session):
    beverage_menu = Menu(name='Beverage')
    food_menu = Menu(name='Food')
    orange_juice = Item(menu=beverage_menu, name='Orange Juice', price=149)
    short_stack = Item(menu=food_menu, name='Pancakes', price=399)
    regular_pancakes = Item(menu=food_menu, name='Pancakes', price=499)
    first_order = Order(order_items=[OrderItem(item=orange_juice, amount=2)])
    session.add(beverage_menu)
    session.add(food_menu)
    session.add(orange_juice)
    session.add(short_stack)
    session.add(regular_pancakes)
    session.add(first_order)


def main():
    try:
        url = DinerDatabase.construct_mysql_url('localhost', 3306, 'diner', 'root', 'cse1208')
        diner_database = DinerDatabase(url)
        diner_database.ensure_tables_exist()
        print('Tables created.')
        # session = diner_database.create_session()
        # add_starter_data(session)
        # session.commit()
        # print('Records created.')
    except SQLAlchemyError as exception:
        print('Database setup failed!', file=stderr)
        print(f'Cause: {exception}', file=stderr)
        exit(1)


if __name__ == '__main__':
    main()
